<!-- HTML header for doxygen 1.9.8-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.8"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Exemplo: EXEMPLO</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="doxygen-awesome.css" rel="stylesheet" type="text/css"/>
<link href="doxygen-awesome-sidebar-only.css" rel="stylesheet" type="text/css"/>
<link href="doxygen-awesome-sidebar-only-darkmode-toggle.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="doxygen-awesome-darkmode-toggle.js"></script>
  <script type="text/javascript">
      DoxygenAwesomeDarkModeToggle.init()
  </script>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="Cubicverde.png"/></td>
  <td id="projectalign">
   <div id="projectname">Exemplo<span id="projectnumber">&#160;0.0.1</span>
   </div>
   <div id="projectbrief">Este é um exemplo.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.8 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('index.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">EXEMPLO </div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="md__r_e_a_d_m_e"></a> </p><div class="image">
<img src="U&amp;M.png" alt=""/>
</div>
    <h1><a class="anchor" id="autotoc_md1"></a>
Pagina Doxygen</h1>
<p>Para o acesso a pagina do doxygen basta acessar o <a href="https://exemplo-documentacao4-73bcd08d5f815e716f57f7fce56a6eabeb343051e.gitlab.io">Link</a>.</p>
<h1><a class="anchor" id="autotoc_md2"></a>
Objetivo</h1>
<p>Definir, padronizar e automatizar os processos de documentação de códigos, visando uma melhor curva de aprendizado para novos membros, e aumento na assertividade e eficácia da manutenção de softwares.</p>
<h1><a class="anchor" id="autotoc_md3"></a>
Primeiros Passos</h1>
<p>Para a automatização do processo de documentação será utilizada a ferramenta doxygen, que é responsável por criar um <a href="https://exemplo-documentacao4-73bcd08d5f815e716f57f7fce56a6eabeb343051e.gitlab.io">documento externo</a>(.html) com toda a documentação do programa. Para o uso correto do doxygen existem alguns requisitos a serem cumpridos.</p>
<h2><a class="anchor" id="autotoc_md4"></a>
Arquivos requeridos</h2>
<p>Existem alguns arquivos que são necessarios para o funcionamento do sistema estes arquivos, logo deve-se se fazer o download desses arquivos e inseri-los na pasta do projeto, como é explicado abaixo.</p>
<h3><a class="anchor" id="autotoc_md5"></a>
Download dos arquivos</h3>
<p>Ao acessar o <a href="https://gitlab.com/documentacao4/exemplo">repositório</a>, deve-se realizar o download dos arquivos, seguindo dos seguintes passos.</p>
<ul>
<li>1º Passo:</li>
</ul>
<div class="image">
<img src="passo1download.png" alt=""/>
</div>
    <ul>
<li>2º Passo:</li>
</ul>
<div class="image">
<img src="passo2download.png" alt=""/>
</div>
    <p>ou utilizando o comando git, desse modo basta abrir o terminal git e executar o comando abaixo, dessa forma os arquivo do repositório serão baixados.</p>
<pre class="fragment"> git clone https://gitlab.com/documentacao4/exemplo.git
</pre><h3><a class="anchor" id="autotoc_md6"></a>
Local dos arquivos</h3>
<p>Na pasta do projeto devem ser adicionados a pasta "docs" e o arquivo ".gitlab-ci.yml", estas pastas foram baixadas junto do repositório basta copiá-las para o arquivo do projeto.</p>
<div class="image">
<img src="PastaDoxyTest.PNG" alt=""/>
</div>
    <h3><a class="anchor" id="autotoc_md7"></a>
Pasta "docs"</h3>
<p>A pasta "docs", contém as pastas "Documentation", responsável pelo output do doxygen, "Custom", responsável pelas configurações do doxygen e "Images", onde devem ser inseridas as imagens presentes na documentação.</p>
<div class="image">
<img src="PastaDocsTest.PNG" alt=""/>
</div>
    <h3><a class="anchor" id="autotoc_md8"></a>
Pipeline</h3>
<p>A pipeline de um projeto, é uma serie de tarefas automatizadas que podem ser executadas a partir de um commit, comandadas pelo arquivo ".gitlab-ci.yml", trazendo uma integração continua da documentação e outras tarefas configuradas às mudanças do código.</p>
<div class="image">
<img src="pipeline.png" alt=""/>
</div>
    <h3><a class="anchor" id="autotoc_md9"></a>
Arquivo ".gitlab-ci.yml"</h3>
<p>Este arquivo tem a função acionar e comandar a pipeline do projeto, gerando os arquivos doxygen a cada "git push" realizado pelo desenvolvedor.</p>
<p>O primeiro passo para configurar o arquivo ".yml" é definir a imagem docker que será utilizada está ira contar as bibliotecas e dependências necessárias para que aplicação funcione. </p><pre class="fragment">  image: alpine
</pre><p>O segundo passo, é adicionar a ferramenta doxygen a nossa imagem.</p>
<pre class="fragment">  before_script:
  - apk update
  - apk add doxygen
</pre><p>Em seguida, são definidos as tarefas "test", "pages","jobs" e etc, contendo nestas os scripts a serem executados dentro de cada etapa, lembrando que o "pages" é o utilizado por criar um link externo, que será utilizado para acesso da documentação.</p>
<pre class="fragment">  test:
    script:
    - doxygen docs/Doxyfile/Doxyfile
    rules:
      - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH

  pages:
    script:
    - doxygen docs/Doxyfile/Doxyfile
    - mv docs/documentation/html/ public/
    artifacts:
      paths:
      - public
    rules:
      - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
</pre><p> Sendo assim, este é o código completo do arquivo ".gitlab-ci.yml".</p>
<pre class="fragment">  image: alpine

  before_script:
  - apk update
  - apk add doxygen

  test:
    script:
    - doxygen docs/Doxyfile/Doxyfile
    rules:
      - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH

  pages:
    script:
    - doxygen docs/Doxyfile/Doxyfile
    - mv docs/documentation/html/ public/
    artifacts:
      paths:
      - public
    rules:
      - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
</pre><h3><a class="anchor" id="autotoc_md10"></a>
Arquivo "Doxyfile"</h3>
<p>Para editar o nome, resumo e versão do projeto deve-se acessar o arquivo “Doxyfile” que esta em ".\docs\Doxyfile\Doxyfile", no caso da troca da logo deve-se atentar as restrições de tamanho (MAX: 200px) e local do arquivo. Dentro do arquivo Doxyfile devem ser editados essas funções.</p>
<pre class="fragment">  PROJECT_NAME           = Nome Do Projeto
  PROJECT_NUMBER         = 0.0.1
  PROJECT_BRIEF          = Breve resumo sobre o projeto.
  PROJECT_LOGO           = ./docs/Doxyfile/imagem.png
</pre><p> Para ignorar pastas e arquivos que os conteúdos não devem estar na página basta utilizar essa função no doxyfile.</p>
<pre class="fragment">  EXCLUDE_PATTERNS       = */nomepasta/*
</pre><p> ou </p><pre class="fragment">  EXCLUDE_PATTERNS       = ./docs/arquivo.py
</pre> <h1><a class="anchor" id="autotoc_md11"></a>
Documentação</h1>
<h2><a class="anchor" id="autotoc_md12"></a>
Arquivo "README.md"</h2>
<p>O arquivo “README” deverá ser utilizado com a finalidade de uma explicação geral sobre o funcionamento, de forma a ilustrar e facilitar para usuário e desenvolvedor o entendimento e uso do programa. Dentro do arquivo “README”, pode ser utilizado as divisões de capitulo, sessão e subseção, como ilustrado no exemplo a baixo.</p>
<pre class="fragment">  # PAGINA
  ## CAPITULO
  ### SESSÃO
  #### SUBSEÇÃO 
</pre><div class="image">
<img src="exemplosessao.PNG" alt=""/>
</div>
    <p>Para adição de imagens, devemos utilizar o comando:</p>
<pre class="fragment">  ![](./docs/Images/imagem.png)
</pre><p>Outros comandos a serem utilizados no "README" podem ser encontrados nesse <a href="https://rmarkdown.rstudio.com/authoring_basics.html">link</a>.</p>
<h2><a class="anchor" id="autotoc_md13"></a>
Documentação dentro do Código</h2>
<p>Para a documentação especifica do código deverão ser utilizados algumas "tags", sendo as principais.</p>
<ul>
<li>"@brief" Utilizado para breves resumos de funções inseridas dentro do programa.</li>
<li>"@param" Descreve parâmetros de uma função.</li>
</ul>
<p>Outras tags podem ser encontradas <a href="https://www.doxygen.nl/manual/commands.html">aqui</a>. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Thu Dec 21 2023 11:10:05 for Exemplo by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.8 </li>
  </ul>
</div>
</body>
</html>
